TanStack
Core Guides

Custom Features (Solid) Guide

Use getters for reactive inputs such as data when passing Solid signals to createTable.

In this guide, we'll cover how to extend TanStack Table with custom features, and along the way, we'll learn more about how the TanStack Table v9 codebase is structured and how it works.

TanStack Table Strives to be Lean

TanStack Table has a core set of features that are built into the library such as sorting, filtering, pagination, etc. We've received a lot of requests and sometimes even some well thought out PRs to add even more features to the library. While we are always open to improving the library, we also want to make sure that TanStack Table remains a lean library that does not include too much bloat and code that is unlikely to be used in most use cases. Not every PR can, or should, be accepted into the core library, even if it does solve a real problem. This can be frustrating to developers when TanStack Table solves 90% of their use case, but they need a little bit more control.

TanStack Table has always been built in a way that allows it to be highly extensible (at least since v7). The table instance that is returned from whichever framework adapter that you are using (createTable for Solid, useTable for React, etc) is a plain JavaScript object that can have extra properties or APIs added to it. It has always been possible to use composition to add custom logic, state, and APIs to the table instance. Libraries like Material React Table have simply created custom wrappers around their adapter's table function to extend the table instance with custom functionality.

In v9, TanStack Table uses the features option (via tableFeatures()) to declare which features your table uses. This enables tree-shaking: you only bundle the code for the features you need. You can add custom features to the table instance in exactly the same way as the built-in features.

In v9, features are opt-in. Use tableFeatures({ ... }) to declare which features your table uses, including custom features.

How TanStack Table Features Work

TanStack Table's source code is arguably somewhat simple (at least we think so). All code for each feature is split up into its own object/file with instantiation methods to create initial state, default table and column options, and API methods that can be added to the table, header, column, row, and cell instances.

All of the functionality of a feature object can be described with the TableFeature type that is exported from TanStack Table. This type is a TypeScript interface that describes the shape of a feature object needed to create a feature.

ts
export interface TableFeature {
  assignCellPrototype?: <
    TFeatures extends TableFeatures,
    TData extends RowData,
  >(
    prototype: Record<string, any>,
    table: Table_Internal<TFeatures, TData>,
  ) => void
  assignColumnPrototype?: <
    TFeatures extends TableFeatures,
    TData extends RowData,
  >(
    prototype: Record<string, any>,
    table: Table_Internal<TFeatures, TData>,
  ) => void
  assignHeaderPrototype?: <
    TFeatures extends TableFeatures,
    TData extends RowData,
  >(
    prototype: Record<string, any>,
    table: Table_Internal<TFeatures, TData>,
  ) => void
  assignRowPrototype?: <TFeatures extends TableFeatures, TData extends RowData>(
    prototype: Record<string, any>,
    table: Table_Internal<TFeatures, TData>,
  ) => void
  constructTableAPIs?: <TFeatures extends TableFeatures, TData extends RowData>(
    table: Table_Internal<TFeatures, TData>,
  ) => void
  initTableInstanceData?: <
    TFeatures extends TableFeatures,
    TData extends RowData,
  >(
    table: Table_Internal<TFeatures, TData>,
  ) => void
  getDefaultColumnDef?: <
    TFeatures extends TableFeatures,
    TData extends RowData,
    TValue extends CellData = CellData,
  >() => ColumnDefBase_All<TFeatures, TData, TValue>
  getDefaultTableOptions?: <
    TFeatures extends TableFeatures,
    TData extends RowData,
  >(
    table: Table_Internal<TFeatures, TData>,
  ) => Partial<TableOptions_All<TFeatures, TData>>
  getInitialState?: (initialState: Partial<TableState_All>) => TableState_All
  initCellInstanceData?: <
    TFeatures extends TableFeatures,
    TData extends RowData,
    TValue extends CellData = CellData,
  >(
    cell: Cell<TFeatures, TData, TValue>,
  ) => void
  initColumnInstanceData?: <
    TFeatures extends TableFeatures,
    TData extends RowData,
    TValue extends CellData = CellData,
  >(
    column: Column<TFeatures, TData, TValue>,
  ) => void
  initHeaderGroupInstanceData?: <
    TFeatures extends TableFeatures,
    TData extends RowData,
  >(
    headerGroup: HeaderGroup<TFeatures, TData>,
  ) => void
  initHeaderInstanceData?: <
    TFeatures extends TableFeatures,
    TData extends RowData,
    TValue extends CellData = CellData,
  >(
    header: Header<TFeatures, TData, TValue>,
  ) => void
  initRowInstanceData?: <
    TFeatures extends TableFeatures,
    TData extends RowData,
  >(
    row: Row<TFeatures, TData>,
  ) => void
  resetTableInstanceData?: <
    TFeatures extends TableFeatures,
    TData extends RowData,
  >(
    table: Table_Internal<TFeatures, TData>,
  ) => void
}

This might be a bit confusing, so let's break down what each of these methods does:

Default Options and Initial State


getDefaultTableOptions

The getDefaultTableOptions method in a table feature is responsible for setting the default table options for that feature. For example, in the Column Resizing feature, the getDefaultTableOptions method sets the default columnResizeMode option with a default value of "onEnd".


getDefaultColumnDef

The getDefaultColumnDef method in a table feature is responsible for setting the default column options for that feature. For example, in the Sorting feature, the getDefaultColumnDef method sets the default sortUndefined column option with a default value of 1.


getInitialState

The getInitialState method in a table feature is responsible for setting the default state for that feature. For example, in the Pagination feature, the getInitialState method sets the default pageSize state with a value of 10 and the default pageIndex state with a value of 0.

API Creators


initTableInstanceData and resetTableInstanceData

Use initTableInstanceData for mutable, non-reactive data that belongs to one table instance, such as an interaction anchor or an imperative cache. It runs once after table options, state atoms, and the store have been created. Features are processed in a single pass in registration order; each feature's initialization hook runs just before that feature's constructTableAPIs hook, so hooks may rely on data and APIs from features registered earlier.

Use resetTableInstanceData to clear that transient data when table.reset() runs. Reset hooks run after internally owned table state atoms have been restored to table.initialState. They do not reset table state slices or externally controlled state, and table.reset() does not rerun initTableInstanceData.

Keep API assignment in constructTableAPIs; initialization and reset hooks are for data owned by the feature.


constructTableAPIs

The constructTableAPIs method in a table feature is exclusively responsible for adding methods to the table instance. It runs after all feature-owned table instance data has been initialized. For example, in the Row Selection feature, the constructTableAPIs method adds many table instance API methods such as toggleAllRowsSelected, getIsAllRowsSelected, getIsSomeRowsSelected, etc. So then, when you call table.toggleAllRowsSelected(), you are calling a method that was added to the table instance by the rowSelectionFeature feature.


assignHeaderPrototype and initHeaderInstanceData

The assignHeaderPrototype method in a table feature is responsible for adding methods to the shared header prototype. For example, the Column Sizing feature adds header instance API methods such as getStart. So then, when you call header.getStart(), you are calling a method that was added by the column sizing feature. The initHeaderInstanceData method is available for per-header instance data or caches that cannot live on the shared prototype. It runs during header construction, before sub-headers are populated and before the header is linked to its header group. Headers are reconstructed whenever header groups recompute, so it reruns on every rebuild.


initHeaderGroupInstanceData

The initHeaderGroupInstanceData method is available for per-header-group instance data. Header groups have no shared prototype, so this is their only per-instance extension point. It runs after a header group's depth, id, and fully populated headers array have been assigned, and reruns whenever header groups are rebuilt.


assignColumnPrototype and initColumnInstanceData

The assignColumnPrototype method in a table feature is responsible for adding methods to the shared column prototype. For example, the Sorting feature adds column instance API methods such as getNextSortingOrder, toggleSorting, etc. So then, when you call column.toggleSorting(), you are calling a method that was added by the row sorting feature. The initColumnInstanceData method is available for per-column instance data or caches that cannot live on the shared prototype. For example, the Aggregation feature uses it to set up a per-column aggregation cache.


assignRowPrototype and initRowInstanceData

The assignRowPrototype method in a table feature is responsible for adding methods to the shared row prototype. The initRowInstanceData method is available for per-row instance data or caches that cannot live on the shared prototype. For example, the Row Selection feature adds row instance API methods such as toggleSelected and getIsSelected.


assignCellPrototype and initCellInstanceData

The assignCellPrototype method in a table feature is responsible for adding methods to the shared cell prototype. For example, Column Grouping adds getIsGrouped and getIsPlaceholder, while Aggregation adds getIsAggregated. The initCellInstanceData method is available for per-cell instance data or caches that cannot live on the shared prototype. Cells are constructed lazily on first access per row/column pair and cached, so it runs once per cell instance.

Adding a Custom Feature

Let's walk through making a custom table feature for a hypothetical use case. Let's say we want to add a feature to the table instance that allows the user to change the "density" (padding of cells) of the table.

There is no Solid custom-plugin example in the repository yet (the example currently exists for React, Preact, and Angular), but the feature object itself is framework-agnostic, so the steps below translate directly. Here's an in-depth look at the steps to create a custom feature.

Step 1: Set up TypeScript Types

Assuming you want the same full type-safety that the built-in features in TanStack Table have, let's set up all of the TypeScript types for our new feature. We'll create types for new table options, state, and table instance API methods.

These types are following the naming convention used internally within TanStack Table, but you can name them whatever you want. We are not adding these types to TanStack Table yet, but we'll do that in the next step.

ts
// define types for our new feature's custom state
export type DensityState = 'sm' | 'md' | 'lg'
export interface TableState_Density {
  density: DensityState
}

// define types for our new feature's table options
export interface TableOptions_Density {
  enableDensity?: boolean
  onDensityChange?: OnChangeFn<DensityState>
}

// Define types for our new feature's table APIs
export interface Table_Density {
  setDensity: (updater: Updater<DensityState>) => void
  toggleDensity: (value?: DensityState) => void
}

Step 2: Add the Feature to TanStack Table's Feature Maps

TanStack Table uses the keys passed to tableFeatures({ ... }) to infer which feature state, options, and APIs exist on a table. To make a custom feature key type-safe, add it to the exported Plugins, TableState_FeatureMap, TableOptions_FeatureMap, and Table_FeatureMap interfaces with declaration merging.

ts
declare module '@tanstack/solid-table' {
  interface Plugins {
    densityPlugin: TableFeature
  }

  interface TableState_FeatureMap {
    densityPlugin: TableState_Density
  }

  interface TableOptions_FeatureMap<
    TFeatures extends TableFeatures,
    TData extends RowData,
  > {
    densityPlugin: TableOptions_Density
  }

  interface Table_FeatureMap<
    TFeatures extends TableFeatures,
    TData extends RowData,
  > {
    densityPlugin: Table_Density
  }
}

Once the feature is registered this way, TypeScript can infer the feature's state, options, and APIs only on tables whose features include densityPlugin.

Step 3: Create the Feature Object

With all of that TypeScript setup out of the way, we can now create the feature object for our new feature. This is where we define all of the methods that will be added to the table instance.

Use the TableFeature type to ensure that you are creating the feature object correctly. If the TypeScript types are set up correctly, you should have no TypeScript errors when you create the feature object with the new state, options, and instance APIs.

ts
export const densityPlugin: TableFeature = {
  // define the new feature's initial state
  getInitialState: (initialState) => {
    return {
      density: 'md',
      ...initialState, // must come last
    }
  },

  // define the new feature's default options
  getDefaultTableOptions: (table) => {
    return {
      enableDensity: true,
      onDensityChange: makeStateUpdater('density', table),
    }
  },
  // if you need to add a default column definition...
  // getDefaultColumnDef: () => {},

  // define the new feature's table instance methods
  constructTableAPIs: (table) => {
    assignTableAPIs('densityPlugin', table, {
      table_setDensity: {
        fn: (updater: Updater<DensityState>) => {
          const safeUpdater: Updater<DensityState> = (old) => {
            const newState = functionalUpdate(updater, old)
            return newState
          }
          return table.options.onDensityChange?.(safeUpdater)
        },
      },
      table_toggleDensity: {
        fn: (value?: DensityState) => {
          const safeUpdater: Updater<DensityState> = (old) => {
            if (value) return value
            return old === 'lg' ? 'md' : old === 'md' ? 'sm' : 'lg'
          }
          return table.options.onDensityChange?.(safeUpdater)
        },
      },
    })
  },

  // if you need to add row instance APIs...
  // assignRowPrototype: (prototype, table) => {},
  // initRowInstanceData: (row) => {},
  // if you need to add cell instance APIs...
  // assignCellPrototype: (prototype, table) => {},
  // initCellInstanceData: (cell) => {},
  // if you need to add column instance APIs...
  // assignColumnPrototype: (prototype, table) => {},
  // initColumnInstanceData: (column) => {},
  // if you need to add header instance APIs...
  // assignHeaderPrototype: (prototype, table) => {},
  // initHeaderInstanceData: (header) => {},
  // if you need to add header group instance data...
  // initHeaderGroupInstanceData: (headerGroup) => {},
}

Step 4: Add the Feature to the Table

Now that we have our feature object, we can add it to the table instance by including it in the tableFeatures() call and passing the result to the features option when we create the table instance.

ts
const features = tableFeatures({ densityPlugin })

const table = createTable({
  features,
  columns,
  data,
  //..
})

Step 5: Use the Feature in Your Application

Now that the feature is added to the table instance, you can use the new instance APIs, options, and state in your application. Here the density state is controlled with a Solid signal and the new onDensityChange option:

tsx
const features = tableFeatures({ densityPlugin })

const [density, setDensity] = createSignal<DensityState>('md')

const table = createTable({
  features,
  columns,
  data,
  //...
  state: {
    get density() {
      return density() // passing the density state to the table, TS is still happy :)
    },
  },
  onDensityChange: setDensity,
})
//...
return (
  <td
    style={{
      //using our new feature in the code
      padding: density() === 'sm' ? '4px' : density() === 'md' ? '8px' : '16px',
      transition: 'padding 0.2s',
    }}
  >
    <table.FlexRender cell={cell} />
  </td>
)

Do We Have to Do It This Way?

This is just a new way to integrate custom code alongside the built-in features in TanStack Table. In our example up above, we could have just as easily stored the density state in a createSignal, defined our own toggleDensity handler wherever, and just used it in our code separately from the table instance. Building table features alongside TanStack Table instead of deeply integrating them into the table instance is still a perfectly valid way to build custom features. Depending on your use case, this may or may not be the cleanest way to extend TanStack Table with custom features.

Want to skip to the implementation? Check out these React examples:
In this guide, we'll cover how to extend TanStack Table with custom features, and along the way, we'll learn more about how the TanStack Table v9 codebase is structured and how it works.
TanStack Table has a core set of features that are built into the library such as sorting, filtering, pagination, etc. We've received a lot of requests and sometimes even some well thought out PRs to add even more features to the library. While we are always open to improving the library, we also want to make sure that TanStack Table remains a lean library that does not include too much bloat and code that is unlikely to be used in most use cases. Not every PR can, or should, be accepted into the core library, even if it does solve a real problem. This can be frustrating to developers when TanStack Table solves 90% of their use case, but they need a little bit more control.
TanStack Table has always been built in a way that allows it to be highly extensible (at least since v7). The table instance that is returned from whichever framework adapter that you are using (createTable, useTable, etc) is a plain JavaScript object that can have extra properties or APIs added to it. It has always been possible to use composition to add custom logic, state, and APIs to the table instance. Libraries like Material React Table have simply created custom wrapper hooks around the useTable hook to extend the table instance with custom functionality.
In v9, TanStack Table uses the features option (via tableFeatures()) to declare which features your table uses. This enables tree-shaking: you only bundle the code for the features you need. You can add custom features to the table instance in exactly the same way as the built-in features.
In v9, features are opt-in. Use tableFeatures({ ... }) to declare which features your table uses, including custom features.
TanStack Table's source code is arguably somewhat simple (at least we think so). All code for each feature is split up into its own object/file with instantiation methods to create initial state, default table and column options, and API methods that can be added to the table, header, column, row, and cell instances.
All of the functionality of a feature object can be described with the TableFeature type that is exported from TanStack Table. This type is a TypeScript interface that describes the shape of a feature object needed to create a feature.
export interface TableFeature {
assignCellPrototype?: <
TFeatures extends TableFeatures,
TData extends RowData,
>(
prototype: Record<string, any>,
table: Table_Internal<TFeatures, TData>,
) => void
assignColumnPrototype?: <
TFeatures extends TableFeatures,
TData extends RowData,
>(
prototype: Record<string, any>,
table: Table_Internal<TFeatures, TData>,
) => void
assignHeaderPrototype?: <
TFeatures extends TableFeatures,
TData extends RowData,
>(
prototype: Record<string, any>,
table: Table_Internal<TFeatures, TData>,
) => void
assignRowPrototype?: <TFeatures extends TableFeatures, TData extends RowData>(
prototype: Record<string, any>,
table: Table_Internal<TFeatures, TData>,
) => void
constructTableAPIs?: <TFeatures extends TableFeatures, TData extends RowData>(
table: Table_Internal<TFeatures, TData>,
) => void
initTableInstanceData?: <
TFeatures extends TableFeatures,
TData extends RowData,
>(
table: Table_Internal<TFeatures, TData>,
) => void
getDefaultColumnDef?: <
TFeatures extends TableFeatures,
TData extends RowData,
TValue extends CellData = CellData,
>() => ColumnDefBase_All<TFeatures, TData, TValue>
getDefaultTableOptions?: <
TFeatures extends TableFeatures,
TData extends RowData,
>(
table: Table_Internal<TFeatures, TData>,
) => Partial<TableOptions_All<TFeatures, TData>>
getInitialState?: (initialState: Partial<TableState_All>) => TableState_All
initCellInstanceData?: <
TFeatures extends TableFeatures,
TData extends RowData,
TValue extends CellData = CellData,
>(
cell: Cell<TFeatures, TData, TValue>,
) => void
initColumnInstanceData?: <
TFeatures extends TableFeatures,
TData extends RowData,
TValue extends CellData = CellData,
>(
column: Column<TFeatures, TData, TValue>,
) => void
initHeaderGroupInstanceData?: <
TFeatures extends TableFeatures,
TData extends RowData,
>(
headerGroup: HeaderGroup<TFeatures, TData>,
) => void
initHeaderInstanceData?: <
TFeatures extends TableFeatures,
TData extends RowData,
TValue extends CellData = CellData,
>(
header: Header<TFeatures, TData, TValue>,
) => void
initRowInstanceData?: <
TFeatures extends TableFeatures,
TData extends RowData,
>(
row: Row<TFeatures, TData>,
) => void
resetTableInstanceData?: <
TFeatures extends TableFeatures,
TData extends RowData,
>(
table: Table_Internal<TFeatures, TData>,
) => void
}This might be a bit confusing, so let's break down what each of these methods does:
The getDefaultTableOptions method in a table feature is responsible for setting the default table options for that feature. For example, in the Column Resizing feature, the getDefaultTableOptions method sets the default columnResizeMode option with a default value of "onEnd".
The getDefaultColumnDef method in a table feature is responsible for setting the default column options for that feature. For example, in the Sorting feature, the getDefaultColumnDef method sets the default sortUndefined column option with a default value of 1.
The getInitialState method in a table feature is responsible for setting the default state for that feature. For example, in the Pagination feature, the getInitialState method sets the default pageSize state with a value of 10 and the default pageIndex state with a value of 0.
Use initTableInstanceData for mutable, non-reactive data that belongs to one table instance, such as an interaction anchor or an imperative cache. It runs once after table options, state atoms, and the store have been created. Features are processed in a single pass in registration order; each feature's initialization hook runs just before that feature's constructTableAPIs hook, so hooks may rely on data and APIs from features registered earlier.
Use resetTableInstanceData to clear that transient data when table.reset() runs. Reset hooks run after internally owned table state atoms have been restored to table.initialState. They do not reset table state slices or externally controlled state, and table.reset() does not rerun initTableInstanceData.
Keep API assignment in constructTableAPIs; initialization and reset hooks are for data owned by the feature.
The constructTableAPIs method in a table feature is exclusively responsible for adding methods to the table instance. It runs after all feature-owned table instance data has been initialized. For example, in the Row Selection feature, the constructTableAPIs method adds many table instance API methods such as toggleAllRowsSelected, getIsAllRowsSelected, getIsSomeRowsSelected, etc. So then, when you call table.toggleAllRowsSelected(), you are calling a method that was added to the table instance by the rowSelectionFeature feature.
The assignHeaderPrototype method in a table feature is responsible for adding methods to the shared header prototype. For example, the Column Sizing feature adds header instance API methods such as getStart. So then, when you call header.getStart(), you are calling a method that was added by the column sizing feature. The initHeaderInstanceData method is available for per-header instance data or caches that cannot live on the shared prototype. It runs during header construction, before sub-headers are populated and before the header is linked to its header group. Headers are reconstructed whenever header groups recompute, so it reruns on every rebuild.
The initHeaderGroupInstanceData method is available for per-header-group instance data. Header groups have no shared prototype, so this is their only per-instance extension point. It runs after a header group's depth, id, and fully populated headers array have been assigned, and reruns whenever header groups are rebuilt.
The assignColumnPrototype method in a table feature is responsible for adding methods to the shared column prototype. For example, the Sorting feature adds column instance API methods such as getNextSortingOrder, toggleSorting, etc. So then, when you call column.toggleSorting(), you are calling a method that was added by the row sorting feature. The initColumnInstanceData method is available for per-column instance data or caches that cannot live on the shared prototype. For example, the Aggregation feature uses it to set up a per-column aggregation cache.
The assignRowPrototype method in a table feature is responsible for adding methods to the shared row prototype. The initRowInstanceData method is available for per-row instance data or caches that cannot live on the shared prototype. For example, the Row Selection feature adds row instance API methods such as toggleSelected and getIsSelected.
The assignCellPrototype method in a table feature is responsible for adding methods to the shared cell prototype. For example, Column Grouping adds getIsGrouped and getIsPlaceholder, while Aggregation adds getIsAggregated. The initCellInstanceData method is available for per-cell instance data or caches that cannot live on the shared prototype. Cells are constructed lazily on first access per row/column pair and cached, so it runs once per cell instance.
Let's walk through making a custom table feature for a hypothetical use case. Let's say we want to add a feature to the table instance that allows the user to change the "density" (padding of cells) of the table.
Check out the full custom-plugin example to see the full implementation, but here's an in-depth look at the steps to create a custom feature.
Assuming you want the same full type-safety that the built-in features in TanStack Table have, let's set up all of the TypeScript types for our new feature. We'll create types for new table options, state, and table instance API methods.
These types are following the naming convention used internally within TanStack Table, but you can name them whatever you want. We are not adding these types to TanStack Table yet, but we'll do that in the next step.
// define types for our new feature's custom state
export type DensityState = 'sm' | 'md' | 'lg'
export interface TableState_Density {
density: DensityState
}
// define types for our new feature's table options
export interface TableOptions_Density {
enableDensity?: boolean
onDensityChange?: OnChangeFn<DensityState>
}
// Define types for our new feature's table APIs
export interface Table_Density {
setDensity: (updater: Updater<DensityState>) => void
toggleDensity: (value?: DensityState) => void
}TanStack Table uses the keys passed to tableFeatures({ ... }) to infer which feature state, options, and APIs exist on a table. To make a custom feature key type-safe, add it to the exported Plugins, TableState_FeatureMap, TableOptions_FeatureMap, and Table_FeatureMap interfaces with declaration merging.
declare module '@tanstack/react-table' {
interface Plugins {
densityPlugin: TableFeature
}
interface TableState_FeatureMap {
densityPlugin: TableState_Density
}
interface TableOptions_FeatureMap<
TFeatures extends TableFeatures,
TData extends RowData,
> {
densityPlugin: TableOptions_Density
}
interface Table_FeatureMap<
TFeatures extends TableFeatures,
TData extends RowData,
> {
densityPlugin: Table_Density
}
}Once the feature is registered this way, TypeScript can infer the feature's state, options, and APIs only on tables whose features include densityPlugin.
With all of that TypeScript setup out of the way, we can now create the feature object for our new feature. This is where we define all of the methods that will be added to the table instance.
Use the TableFeature type to ensure that you are creating the feature object correctly. If the TypeScript types are set up correctly, you should have no TypeScript errors when you create the feature object with the new state, options, and instance APIs.
export const densityPlugin: TableFeature = {
// define the new feature's initial state
getInitialState: (initialState) => {
return {
density: 'md',
...initialState, // must come last
}
},
// define the new feature's default options
getDefaultTableOptions: (table) => {
return {
enableDensity: true,
onDensityChange: makeStateUpdater('density', table),
}
},
// if you need to add a default column definition...
// getDefaultColumnDef: () => {},
// define the new feature's table instance methods
constructTableAPIs: (table) => {
assignTableAPIs('densityPlugin', table, {
table_setDensity: {
fn: (updater: Updater<DensityState>) => {
const safeUpdater: Updater<DensityState> = (old) => {
const newState = functionalUpdate(updater, old)
return newState
}
return table.options.onDensityChange?.(safeUpdater)
},
},
table_toggleDensity: {
fn: (value?: DensityState) => {
const safeUpdater: Updater<DensityState> = (old) => {
if (value) return value
return old === 'lg' ? 'md' : old === 'md' ? 'sm' : 'lg'
}
return table.options.onDensityChange?.(safeUpdater)
},
},
})
},
// if you need to add row instance APIs...
// assignRowPrototype: (prototype, table) => {},
// initRowInstanceData: (row) => {},
// if you need to add cell instance APIs...
// assignCellPrototype: (prototype, table) => {},
// initCellInstanceData: (cell) => {},
// if you need to add column instance APIs...
// assignColumnPrototype: (prototype, table) => {},
// initColumnInstanceData: (column) => {},
// if you need to add header instance APIs...
// assignHeaderPrototype: (prototype, table) => {},
// initHeaderInstanceData: (header) => {},
// if you need to add header group instance data...
// initHeaderGroupInstanceData: (headerGroup) => {},
}Now that we have our feature object, we can add it to the table instance by including it in the tableFeatures() call and passing the result to the features option when we create the table instance.
const features = tableFeatures({ densityPlugin })
const table = useTable({
features,
columns,
data,
//..
})Now that the feature is added to the table instance, you can use the new instance APIs, options, and state in your application. The custom-plugin example controls the density state with React.useState and the new onDensityChange option:
const features = tableFeatures({ densityPlugin })
const [density, setDensity] = React.useState<DensityState>('md')
const table = useTable({
features,
columns,
data,
//...
state: {
density, // passing the density state to the table, TS is still happy :)
},
onDensityChange: setDensity,
})
//...
return (
<td
key={cell.id}
style={{
//using our new feature in the code
padding: density === 'sm' ? '4px' : density === 'md' ? '8px' : '16px',
transition: 'padding 0.2s',
}}
>
<table.FlexRender cell={cell} />
</td>
)This is just a new way to integrate custom code alongside the built-in features in TanStack Table. In our example up above, we could have just as easily stored the density state in a React.useState, defined our own toggleDensity handler wherever, and just used it in our code separately from the table instance. Building table features alongside TanStack Table instead of deeply integrating them into the table instance is still a perfectly valid way to build custom features. Depending on your use case, this may or may not be the cleanest way to extend TanStack Table with custom features.